/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignPatchable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignPatchable{}

// CampaignPatchable struct for CampaignPatchable
type CampaignPatchable struct {
	TargetChannels []CampaignPatchableTargetChannelsInner `json:"target_channels,omitempty"`
	TargetContacts []CampaignPatchableTargetContactsInner `json:"target_contacts,omitempty"`
}

// NewCampaignPatchable instantiates a new CampaignPatchable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignPatchable() *CampaignPatchable {
	this := CampaignPatchable{}
	return &this
}

// NewCampaignPatchableWithDefaults instantiates a new CampaignPatchable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignPatchableWithDefaults() *CampaignPatchable {
	this := CampaignPatchable{}
	return &this
}

// GetTargetChannels returns the TargetChannels field value if set, zero value otherwise.
func (o *CampaignPatchable) GetTargetChannels() []CampaignPatchableTargetChannelsInner {
	if o == nil || IsNil(o.TargetChannels) {
		var ret []CampaignPatchableTargetChannelsInner
		return ret
	}
	return o.TargetChannels
}

// GetTargetChannelsOk returns a tuple with the TargetChannels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignPatchable) GetTargetChannelsOk() ([]CampaignPatchableTargetChannelsInner, bool) {
	if o == nil || IsNil(o.TargetChannels) {
		return nil, false
	}
	return o.TargetChannels, true
}

// HasTargetChannels returns a boolean if a field has been set.
func (o *CampaignPatchable) HasTargetChannels() bool {
	if o != nil && !IsNil(o.TargetChannels) {
		return true
	}

	return false
}

// SetTargetChannels gets a reference to the given []CampaignPatchableTargetChannelsInner and assigns it to the TargetChannels field.
func (o *CampaignPatchable) SetTargetChannels(v []CampaignPatchableTargetChannelsInner) {
	o.TargetChannels = v
}

// GetTargetContacts returns the TargetContacts field value if set, zero value otherwise.
func (o *CampaignPatchable) GetTargetContacts() []CampaignPatchableTargetContactsInner {
	if o == nil || IsNil(o.TargetContacts) {
		var ret []CampaignPatchableTargetContactsInner
		return ret
	}
	return o.TargetContacts
}

// GetTargetContactsOk returns a tuple with the TargetContacts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignPatchable) GetTargetContactsOk() ([]CampaignPatchableTargetContactsInner, bool) {
	if o == nil || IsNil(o.TargetContacts) {
		return nil, false
	}
	return o.TargetContacts, true
}

// HasTargetContacts returns a boolean if a field has been set.
func (o *CampaignPatchable) HasTargetContacts() bool {
	if o != nil && !IsNil(o.TargetContacts) {
		return true
	}

	return false
}

// SetTargetContacts gets a reference to the given []CampaignPatchableTargetContactsInner and assigns it to the TargetContacts field.
func (o *CampaignPatchable) SetTargetContacts(v []CampaignPatchableTargetContactsInner) {
	o.TargetContacts = v
}

func (o CampaignPatchable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignPatchable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.TargetChannels) {
		toSerialize["target_channels"] = o.TargetChannels
	}
	if !IsNil(o.TargetContacts) {
		toSerialize["target_contacts"] = o.TargetContacts
	}
	return toSerialize, nil
}

type NullableCampaignPatchable struct {
	value *CampaignPatchable
	isSet bool
}

func (v NullableCampaignPatchable) Get() *CampaignPatchable {
	return v.value
}

func (v *NullableCampaignPatchable) Set(val *CampaignPatchable) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignPatchable) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignPatchable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignPatchable(val *CampaignPatchable) *NullableCampaignPatchable {
	return &NullableCampaignPatchable{value: val, isSet: true}
}

func (v NullableCampaignPatchable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignPatchable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


